SGP = {
	DefaultSettings = {	};
	Settings = {
		GuildName;
		GuildNumRanks;
		GuildRanks = { };
		ReputationList = { };
		MemberList = { };
		MemberTallyList = { };
		DebugMode = false;
	}; -- Currently in use Settings
	Version = "2.00.09";
	VersionNumber = 20009;
	UIRendered = nil;
	SettingsLoaded = nil;
	HEADER = "|cff69CCF0<SGP>|r: ";
	
	PromoteList = { };
	DemoteList = { };
};

SGPFrameStuff = {
	DROPDOWNS = { };
	EDITBOXES = { };
	CHECKBOXES = { };
	BUTTONS = { };
	BUTTONTEXTS = { };
	LISTS = { };
	UIFRAME = nil;
	PROMOTELISTFRAME = nil;
	DEMOTELISTFRAME = nil;
	
	ScrollFrameX = 10;
	ScrollFrameY = -10;
	ScrollFrameStep = 30;

	DefaultX = 10;
	MainContentX = 20;
	MainContentX2 = 40;
	
	MainHeaderY = -10;
	MainRanksTextY = -40;
	MainRanksDescriptionY = -60;
	MainAltsTextY = -160;
	MainAltsDescriptionY = -180;
	MainFiltersTextY = -275;
	MainFiltersDescriptionY = -295;
	
	-- Rank Stuff
	RankManagementHeaderY = -10;
	
	RankHeaderX = 20;
	RankContentX = 40;
	RankContentX2 = 210;
	RankContentX3 = 380;
	RankContentX4 = 68;
	RankContentX5 = 238;
	RanksListBaseY = -40;
	
	RanksListHeightOffset = 185;
	RankCheckboxOffset = 20;
	TotalXPOffset = 55;
	WeeklyXPOffset = 80;
	LevelOffset = 105;
	AchievementOffset = 130;
	ReputationOffset = 155;
	
	-- Alt Stuff
	AltManagementHeaderY = -10;
	
	AltHeaderX = 20;
	AltContentX = 40;
	AltContentX2 = 180;
	AltContentX3 = 60;
	AltContentX4 = 210;
	
	AltNoteTextY = -40;
	AltNoteDescriptionY = -60;
	AltNoteButtonY = -85;
	AltModeTextY = -130;
	AltModeDescriptionY = -150;
	AltModeButtonY = -175;
	
	-- Filter Stuff
	FilterManagementHeaderY = -10;
	
	FilterHeaderX = 20;
	FilterContentX = 40;
	FilterContentX2 = 180;
	FilterContentX3 = 60;
	FilterContentX4 = 260;
	
	FilterDoNotPromoteTextY = -40;
	FilterDoNotPromoteDescriptionY = -60;
	FilterDoNotPromoteButtonY = -115;
	FilterDoNotDemoteTextY = -160;
	FilterDoNotDemoteDescriptionY = -180;
	FilterDoNotDemoteButtonY = -235;
	FilterDoNotListTextY = -280;
	FilterDoNotListDescriptionY = -300;
	FilterDoNotListButtonY = -375;
	
	-- UI Stuff
	UIWidth = 240;
	UIHeight = 300;
	UIPadding = 0;
	
	UIX = 0;
	
	UIHeaderY = -35;
	UIFindButtonY = -70;
	UIBothButtonY = -120;
	UIPromoteButtonY = -155;
	UIDemoteButtonY = -190;
	UISettingsButtonY = -240;
	
	-- List Stuff
	UIListWidth = 250;
	
	PromoteListX = 0;
	DemoteListX = 0;
	
	PromoteListTextY = -20;
	PromoteListY = -40;
	DemoteListTextY = -20;
	DemoteListY = -40;
	
};

SGPData = { }; -- Saved Settings
	
function SGP_ChatEcho(txt)
	DEFAULT_CHAT_FRAME:AddMessage(SGP.HEADER .. txt, 0.25, 1.0, 0.25);
end

function SGP_ErrorEcho(txt)
	DEFAULT_CHAT_FRAME:AddMessage(SGP.HEADER .. txt, 1.0, 0.5, 0.5);
end

function SGP_DebugEcho(txt)
	if (SGP.Settings.DebugMode) then
		DEFAULT_CHAT_FRAME:AddMessage(SGP.HEADER .. txt, 0.75, 1.0, 0.25);
	end
end

function SGP_OnLoad()
	GuildRoster()
	SGPFrame:RegisterEvent("GUILD_ROSTER_UPDATE");
end

function SGP_OnEvent(self, event, ...)
	if (event == "GUILD_ROSTER_UPDATE") then
		SGP_DebugEcho("Guild Roster was updated.");
		RegisterAddonMessagePrefix("SGP");
		SGP.Settings.GuildName = GetGuildInfo("player");
		if (SGP.Settings.GuildName ~= nil and SGP.Settings.GuildName ~= "") then
			if ( SettingsLoaded == nil ) then
				if (not SGPData[SGP.Settings.GuildName] or SGPData[SGP.Settings.GuildName] == nil) then
					-- We need to make a new guild.
					SGP_CreateNewGuildSaveData(SGP.Settings.GuildName);
				else
					-- We need to load from save data.
					SGP_LoadSettings();
				end
				SettingsLoaded = true;
			end
			SGP_RenderOptions();
		end
	end
end

function SGP_CreateNewGuildSaveData(GuildName)
	SGP_DebugEcho("Making new guild save data with name: " .. GuildName .. ".")
	GuildRoster();
	local numRanks = GuildControlGetNumRanks();
	local ranks = { };
	-- Defaults for when new guild is made.
	for i=1,numRanks do -- We include GM here so we can get it's Guild Name if we have to.
		ranks[i] = {
			RankName = GuildControlGetRankName(i);
			RankIndex = i;
			TotalXP = 0;
			WeeklyXP = 0;
			Level = 0;
			Achievement = 0;
			Reputation = 4; -- 4 is Neutral just for reference. 8 is Exalted.
			Attainable = 0;
			AllowPromote = 0;
			AllowDemote = 0;
		};
	end
	SGP.Settings.GuildNumRanks = numRanks;
	SGP.Settings.GuildRanks = ranks;
	SGP.Settings.AltNote = 1;
	SGP.Settings.AltMode = 1;
	SGP.Settings.AltRank = numRanks-1;
	SGP.Settings.FilterDNP = 3;
	SGP.Settings.FilterDNPText = "DNP";
	SGP.Settings.FilterDND = 3;
	SGP.Settings.FilterDNDText = "DND";
	SGP.Settings.FilterDNL = 3;
	SGP.Settings.FilterDNLText = "DNL";
end

function SGP_SaveSettings()
	GuildRoster();
	local GuildName = SGP.Settings.GuildName;
	if ( SGP.UIRendered ~= nil and GuildName ~= nil ) then
		SGP_DebugEcho("Saving Settings.");

		-- Save to SGPData from Raw data.
		SGPData[GuildName] = {
			GuildNumRanks = SGP.Settings.GuildNumRanks;
			GuildRanks = SGP.Settings.GuildRanks;
			AltNote = SGP.Settings.AltNote;
			AltMode = SGP.Settings.AltMode;
			AltRank = SGP.Settings.AltRank;
			FilterDNP = SGP.Settings.FilterDNP;
			FilterDNPText = SGP.Settings.FilterDNPText;
			FilterDND = SGP.Settings.FilterDND;
			FilterDNDText = SGP.Settings.FilterDNDText;
			FilterDNL = SGP.Settings.FilterDNL;
			FilterDNLText = SGP.Settings.FilterDNLText;
		};
	end
end

function SGP_LoadSettings()
	SGP_DebugEcho("Loading Settings.");
	GuildRoster();
	local GuildName = SGP.Settings.GuildName;
	local GuildNumRanks = GuildControlGetNumRanks();
	local GuildRanks = { };
	for i=1,GuildNumRanks do
		table.insert(GuildRanks, GuildControlGetRankName(i));
	end
	-- If our saved number of ranks matches, and the list of ranks match, then we're good to go, otherwise, use new data.
	if ( SGPData[GuildName].GuildNumRanks == GuildNumRanks and SGP_CompareRanks(GuildRanks, SGPData[GuildName].GuildRanks) ) then
		SGP.Settings.GuildNumRanks = SGPData[GuildName].GuildNumRanks;
		SGP.Settings.GuildRanks = SGPData[GuildName].GuildRanks;
		SGP.Settings.AltMode = SGPData[GuildName].AltMode;
		SGP.Settings.AltRank = SGPData[GuildName].AltRank;
		SGP.Settings.FilterDNP = SGPData[GuildName].FilterDNP;
		SGP.Settings.FilterDNPText = SGPData[GuildName].FilterDNPText;
		SGP.Settings.FilterDND = SGPData[GuildName].FilterDND;
		SGP.Settings.FilterDNDText = SGPData[GuildName].FilterDNDText;
		-- Because FilterDNL is new, adding this to make sure it loads.
		if (SGPData[GuildName].FilterDNL ~= nil and SGPData[GuildName].FilterDNLText ~= nil) then
			SGP.Settings.FilterDNL = SGPData[GuildName].FilterDNL;
			SGP.Settings.FilterDNLText = SGPData[GuildName].FilterDNLText;
		else
			SGP.Settings.FilterDNL = 3;
			SGP.Settings.FilterDNLText = "DNL";
		end
		-- Because AltNote is new, adding this to make sure it loads.
		if (SGPData[GuildName].AltNote ~= nil) then
			SGP.Settings.AltNote = SGPData[GuildName].AltNote;
		else
			SGP.Settings.AltNote = 1;
		end
		SGP_DebugEcho("Loaded.");
	else 
		SGP_CreateNewGuildSaveData(GuildName);
	end
end

function SGP_CompareRanks(ranks,data)
	SGP_DebugEcho("Comparing actual ranks with saved ranks.");
	for i,v in pairs(ranks) do
		if (v ~= data[i].RankName) then
			return false;
		end
	end
	return true;
end

function SGP_RenderOptions()
	GuildRoster();
	local GuildName = GetGuildInfo("player");
	
	if ( SGP.UIRendered == nil and GuildName ~= nil ) then
		SGP_DebugEcho("Rendering Options.");
		SGP.UIRendered = true;
		
		-- Main Frame
		
		local ConfigPanel = CreateFrame("FRAME", "SGP_MainFrame");
		ConfigPanel.name = SGPLocal.SGPShort;
		InterfaceOptions_AddCategory(ConfigPanel);
		
		local MainHeader = ConfigPanel:CreateFontString(nil, "ARTWORK", "GameFontGreenLarge");
		MainHeader:SetPoint("TOPLEFT", SGPFrameStuff.DefaultX, SGPFrameStuff.MainHeaderY);
		MainHeader:SetText("Swyn's " .. SGPLocal.GuildPromoter .. " - " .. SGP.Version);
		
		MainRanksText = ConfigPanel:CreateFontString(nil, "ARTWORK", "GameFontNormal");
		MainRanksText:SetPoint("TOPLEFT", SGPFrameStuff.MainContentX, SGPFrameStuff.MainRanksTextY);
		MainRanksText:SetText(SGPLocal.MainRanksText);
		
		MainRanksDescription = ConfigPanel:CreateFontString(nil, "ARTWORK", "GameFontHighlightSmall");
		MainRanksDescription:SetPoint("TOPLEFT", SGPFrameStuff.MainContentX2, SGPFrameStuff.MainRanksDescriptionY);
		MainRanksDescription:SetText(SGPLocal.MainRanksDescription);
		MainRanksDescription:SetJustifyH("LEFT");
		
		MainAltsText = ConfigPanel:CreateFontString(nil, "ARTWORK", "GameFontNormal");
		MainAltsText:SetPoint("TOPLEFT", SGPFrameStuff.MainContentX, SGPFrameStuff.MainAltsTextY);
		MainAltsText:SetText(SGPLocal.MainAltsText);
		
		MainAltsDescription = ConfigPanel:CreateFontString(nil, "ARTWORK", "GameFontHighlightSmall");
		MainAltsDescription:SetPoint("TOPLEFT", SGPFrameStuff.MainContentX2, SGPFrameStuff.MainAltsDescriptionY);
		MainAltsDescription:SetText(SGPLocal.MainAltsDescription);
		MainAltsDescription:SetJustifyH("LEFT");
		
		MainFiltersText = ConfigPanel:CreateFontString(nil, "ARTWORK", "GameFontNormal");
		MainFiltersText:SetPoint("TOPLEFT", SGPFrameStuff.MainContentX, SGPFrameStuff.MainFiltersTextY);
		MainFiltersText:SetText(SGPLocal.MainFiltersText);
		
		MainFiltersDescription = ConfigPanel:CreateFontString(nil, "ARTWORK", "GameFontHighlightSmall");
		MainFiltersDescription:SetPoint("TOPLEFT", SGPFrameStuff.MainContentX2, SGPFrameStuff.MainFiltersDescriptionY);
		MainFiltersDescription:SetText(SGPLocal.MainFiltersDescription);
		MainFiltersDescription:SetJustifyH("LEFT");
		
		-- Ranks Scroll and Content Frames
		
		local RanksPanel = CreateFrame("FRAME","SGP_RanksFrame");
		RanksPanel.name = SGPLocal.RanksPanelName;
		RanksPanel.parent = ConfigPanel.name
		InterfaceOptions_AddCategory(RanksPanel);
		
		local RanksScrollFrame = CreateFrame("ScrollFrame", nil, RanksPanel);
		RanksScrollFrame:SetPoint("TOPLEFT", SGPFrameStuff.ScrollFrameX, SGPFrameStuff.ScrollFrameY);
		RanksScrollFrame:SetPoint("BOTTOMRIGHT", SGPFrameStuff.ScrollFrameY, SGPFrameStuff.ScrollFrameX);
		RanksPanel.scrollframe = RanksScrollFrame;
		
		local RanksScrollBar = CreateFrame("Slider", nil, RanksScrollFrame, "UIPanelScrollBarTemplate");
		RanksScrollBar:SetPoint("TOPLEFT", RanksPanel, "TOPRIGHT", -21, -22);
		RanksScrollBar:SetPoint("BOTTOMLEFT", RanksPanel, "BOTTOMRIGHT", -21, 21);
		local RanksScrollBarMax = ((SGP.Settings.GuildNumRanks-1)*SGPFrameStuff.RanksListHeightOffset)+(-SGPFrameStuff.RanksListBaseY)-550;
		RanksScrollBar:SetMinMaxValues(1, RanksScrollBarMax);
		RanksScrollBar:SetValueStep(1);
		RanksScrollBar.scrollStep = 1;
		RanksScrollBar:SetValue(0);
		RanksScrollBar:SetWidth(16);
		RanksScrollBar:SetScript("OnValueChanged", function (self, value)
													  self:GetParent():SetVerticalScroll(value)
												  end);
		local RanksScrollBarTexture = RanksScrollBar:CreateTexture(nil, "BACKGROUND");
		RanksScrollBarTexture:SetAllPoints(RanksScrollBar);
		RanksScrollBarTexture:SetTexture(0, 0, 0, 0.4);
		RanksPanel.RanksScrollBar = RanksScrollFrame;
		
		RanksScrollFrame:EnableMouseWheel(true);
		RanksScrollFrame:SetScript("OnMouseWheel", function(self, delta)
														if delta == 1 then
															if IsShiftKeyDown() then
																RanksScrollBar:SetValue(1);
															else
																if (RanksScrollBar:GetValue() - SGPFrameStuff.ScrollFrameStep < 1) then
																	RanksScrollBar:SetValue(1);
																else
																	RanksScrollBar:SetValue(RanksScrollBar:GetValue()-SGPFrameStuff.ScrollFrameStep);
																end
															end
														else
															if IsShiftKeyDown() then
																RanksScrollBar:SetValue(RanksScrollBarMax);
															else
																if (RanksScrollBar:GetValue() + SGPFrameStuff.ScrollFrameStep > RanksScrollBarMax) then
																	RanksScrollBar:SetValue(RanksScrollBarMax);
																else
																	RanksScrollBar:SetValue(RanksScrollBar:GetValue()+SGPFrameStuff.ScrollFrameStep);
																end
															end
														end
													end);
		
		local RanksContentPanel = CreateFrame("Frame", nil, RanksScrollFrame);
		RanksContentPanel:SetSize(200, 200);
		RanksScrollFrame.content = RanksContentPanel;
		
		RanksScrollFrame:SetScrollChild(RanksContentPanel);
		
		-- Stuff to put into Content Pane.
		
		local RankManagementHeader = RanksContentPanel:CreateFontString(nil, "ARTWORK", "GameFontGreenLarge");
		RankManagementHeader:SetPoint("TOPLEFT", SGPFrameStuff.DefaultX, SGPFrameStuff.RankManagementHeaderY);
		RankManagementHeader:SetText(SGPLocal.RankManagementHeader);
		
		--[[ Reputation Drop Down Menu Contents ]]
		for i=4,8 do
			table.insert(SGP.Settings.ReputationList, getglobal("FACTION_STANDING_LABEL"..i));
		end
		
		-- Loop over every rank (except GM) and display stuff.
		for i=2,GuildControlGetNumRanks() do
			local heightOffset = (i-2) * SGPFrameStuff.RanksListHeightOffset;
			local rankName = GuildControlGetRankName(i);
			-- Rank Text Header:
			local RankHeader = RanksContentPanel:CreateFontString(nil, "ARTWORK", "GameFontNormal");
			RankHeader:SetPoint("TOPLEFT", SGPFrameStuff.RankHeaderX, (SGPFrameStuff.RanksListBaseY - heightOffset));
			RankHeader:SetText(rankName .. ":");
			-- Watch Checkboxes
			local RankAttainableCheckbox = SGP_CreateCheckbox("Attainable" .. rankName, RanksContentPanel, SGPLocal.AttainableText, SGPFrameStuff.RankContentX, (SGPFrameStuff.RanksListBaseY - heightOffset - SGPFrameStuff.RankCheckboxOffset), SGPLocal.AttainableTooltip);
			local RankAllowPromoteCheckbox = SGP_CreateCheckbox("AllowPromote" .. rankName, RanksContentPanel, SGPLocal.AllowPromoteText, SGPFrameStuff.RankContentX2, (SGPFrameStuff.RanksListBaseY - heightOffset - SGPFrameStuff.RankCheckboxOffset), SGPLocal.AllowPromoteTooltip);
			local RankAllowDemoteCheckbox = SGP_CreateCheckbox("AllowDemote" .. rankName, RanksContentPanel, SGPLocal.AllowDemoteText, SGPFrameStuff.RankContentX3, (SGPFrameStuff.RanksListBaseY - heightOffset - SGPFrameStuff.RankCheckboxOffset), SGPLocal.AllowDemoteTooltip);
			-- Total Guild XP, Weekly Guild XP, Level, Achievement and Reputation Texts.
			local TotalXPText = RanksContentPanel:CreateFontString(nil, "ARTWORK", "GameFontHighlightSmall");
			TotalXPText:SetPoint("TOPLEFT", SGPFrameStuff.RankContentX4, (SGPFrameStuff.RanksListBaseY - heightOffset - SGPFrameStuff.TotalXPOffset));
			TotalXPText:SetText(SGPLocal.Minimum .. " " .. SGPLocal.TotalXP);
			local WeeklyXPText = RanksContentPanel:CreateFontString(nil, "ARTWORK", "GameFontHighlightSmall");
			WeeklyXPText:SetPoint("TOPLEFT", SGPFrameStuff.RankContentX4, (SGPFrameStuff.RanksListBaseY - heightOffset - SGPFrameStuff.WeeklyXPOffset));
			WeeklyXPText:SetText(SGPLocal.Minimum .. " " .. SGPLocal.WeeklyXP);
			local LevelText = RanksContentPanel:CreateFontString(nil, "ARTWORK", "GameFontHighlightSmall");
			LevelText:SetPoint("TOPLEFT", SGPFrameStuff.RankContentX4, (SGPFrameStuff.RanksListBaseY - heightOffset - SGPFrameStuff.LevelOffset));
			LevelText:SetText(SGPLocal.Minimum .. " " .. SGPLocal.Level);
			local AchievementText = RanksContentPanel:CreateFontString(nil, "ARTWORK", "GameFontHighlightSmall");
			AchievementText:SetPoint("TOPLEFT", SGPFrameStuff.RankContentX4, (SGPFrameStuff.RanksListBaseY - heightOffset - SGPFrameStuff.AchievementOffset));
			AchievementText:SetText(SGPLocal.Minimum .. " " .. SGPLocal.Achievement);
			local ReputationText = RanksContentPanel:CreateFontString(nil, "ARTWORK", "GameFontHighlightSmall");
			ReputationText:SetPoint("TOPLEFT", SGPFrameStuff.RankContentX4, (SGPFrameStuff.RanksListBaseY - heightOffset - SGPFrameStuff.ReputationOffset));
			ReputationText:SetText(SGPLocal.Minimum .. " " .. SGPLocal.Reputation);
			-- Total Guild XP, Weekly Guild XP, Level and Achievement Editboxes.
			local TotalGuildXPEditbox = SGP_CreateEditbox("MinTotalXP" .. rankName, RanksContentPanel, 170, 20, SGPFrameStuff.RankContentX5, (SGPFrameStuff.RanksListBaseY - heightOffset - SGPFrameStuff.TotalXPOffset + 6), nil);
			local WeeklyGuildXPEditbox = SGP_CreateEditbox("MinWeeklyXP" .. rankName, RanksContentPanel, 170, 20, SGPFrameStuff.RankContentX5, (SGPFrameStuff.RanksListBaseY - heightOffset - SGPFrameStuff.WeeklyXPOffset + 6), nil);
			local LevelEditbox = SGP_CreateEditbox("MinLevel" .. rankName, RanksContentPanel, 40, 20, SGPFrameStuff.RankContentX5, (SGPFrameStuff.RanksListBaseY - heightOffset - SGPFrameStuff.LevelOffset + 6), nil);
			local AchievementEditbox = SGP_CreateEditbox("MinAchievement" .. rankName, RanksContentPanel, 70, 20, SGPFrameStuff.RankContentX5, (SGPFrameStuff.RanksListBaseY - heightOffset - SGPFrameStuff.AchievementOffset + 6), nil);
			-- Reputation DropDownMenu.
			local ReputationEditbox = SGP_CreateDropDownButton("MinReputation" .. rankName, RanksContentPanel, "TOPLEFT", 130, SGPFrameStuff.RankContentX5 - 22, (SGPFrameStuff.RanksListBaseY - heightOffset - SGPFrameStuff.ReputationOffset + 9), SGP.Settings.ReputationList, nil);
		end
		
		-- Alts Scroll and Content Frames
		
		local AltsPanel = CreateFrame("FRAME","SGP_AltsFrame");
		AltsPanel.name = SGPLocal.AltsPanelName;
		AltsPanel.parent = ConfigPanel.name
		InterfaceOptions_AddCategory(AltsPanel);
		
		local AltsScrollFrame = CreateFrame("ScrollFrame", nil, AltsPanel);
		AltsScrollFrame:SetPoint("TOPLEFT", SGPFrameStuff.ScrollFrameX, SGPFrameStuff.ScrollFrameY);
		AltsScrollFrame:SetPoint("BOTTOMRIGHT", SGPFrameStuff.ScrollFrameY, SGPFrameStuff.ScrollFrameX);
		AltsPanel.scrollframe = AltsScrollFrame;
		
		local AltsScrollBar = CreateFrame("Slider", nil, AltsScrollFrame, "UIPanelScrollBarTemplate");
		AltsScrollBar:SetPoint("TOPLEFT", AltsPanel, "TOPRIGHT", -21, -22);
		AltsScrollBar:SetPoint("BOTTOMLEFT", AltsPanel, "BOTTOMRIGHT", -21, 21);
		local AltsScrollBarMax = 1;
		AltsScrollBar:SetMinMaxValues(1, AltsScrollBarMax);
		AltsScrollBar:SetValueStep(1);
		AltsScrollBar.scrollStep = 1;
		AltsScrollBar:SetValue(0);
		AltsScrollBar:SetWidth(16);
		AltsScrollBar:SetScript("OnValueChanged", function (self, value)
													  self:GetParent():SetVerticalScroll(value)
												  end);
		local AltsScrollBarTexture = AltsScrollBar:CreateTexture(nil, "BACKGROUND");
		AltsScrollBarTexture:SetAllPoints(AltsScrollBar);
		AltsScrollBarTexture:SetTexture(0, 0, 0, 0.4);
		AltsPanel.AltsScrollBar = AltsScrollFrame;
		
		AltsScrollFrame:EnableMouseWheel(true);
		AltsScrollFrame:SetScript("OnMouseWheel", function(self, delta)
														if delta == 1 then
															if IsShiftKeyDown() then
																AltsScrollBar:SetValue(1);
															else
																if (AltsScrollBar:GetValue() - SGPFrameStuff.ScrollFrameStep < 1) then
																	AltsScrollBar:SetValue(1);
																else
																	AltsScrollBar:SetValue(AltsScrollBar:GetValue()-SGPFrameStuff.ScrollFrameStep);
																end
															end
														else
															if IsShiftKeyDown() then
																AltsScrollBar:SetValue(AltsScrollBarMax);
															else
																if (AltsScrollBar:GetValue() + SGPFrameStuff.ScrollFrameStep > AltsScrollBarMax) then
																	AltsScrollBar:SetValue(AltsScrollBarMax);
																else
																	AltsScrollBar:SetValue(AltsScrollBar:GetValue()+SGPFrameStuff.ScrollFrameStep);
																end
															end
														end
													end);
		
		local AltsContentPanel = CreateFrame("Frame", nil, AltsScrollFrame);
		AltsContentPanel:SetSize(200, 200);
		AltsScrollFrame.content = AltsContentPanel;
		
		AltsScrollFrame:SetScrollChild(AltsContentPanel);
		
		-- Stuff to put into Content Pane.
		
		local AltManagementHeader = AltsContentPanel:CreateFontString(nil, "ARTWORK", "GameFontGreenLarge");
		AltManagementHeader:SetPoint("TOPLEFT", SGPFrameStuff.AltHeaderX, SGPFrameStuff.AltManagementHeaderY);
		AltManagementHeader:SetText(SGPLocal.AltManagementHeader);
		
		local AltNoteText = AltsContentPanel:CreateFontString(nil, "ARTWORK", "GameFontNormal");
		AltNoteText:SetPoint("TOPLEFT", SGPFrameStuff.AltContentX, SGPFrameStuff.AltNoteTextY);
		AltNoteText:SetText(SGPLocal.AltNoteText);
		
		local AltNoteDescription = AltsContentPanel:CreateFontString(nil, "ARTWORK", "GameFontHighlightSmall");
		AltNoteDescription:SetPoint("TOPLEFT", SGPFrameStuff.AltContentX+5, SGPFrameStuff.AltNoteDescriptionY);
		AltNoteDescription:SetText(SGPLocal.AltNoteDescription);
		
		local AltNoteButton = SGP_CreateDropDownButton("AltNoteButton", AltsContentPanel, "TOPLEFT", 180, SGPFrameStuff.AltContentX3, SGPFrameStuff.AltNoteButtonY, SGPLocal.AltNoteButtonItems, SGPLocal.AltNoteButtonTooltips);
		
		local AltModeText = AltsContentPanel:CreateFontString(nil, "ARTWORK", "GameFontNormal");
		AltModeText:SetPoint("TOPLEFT", SGPFrameStuff.AltContentX, SGPFrameStuff.AltModeTextY);
		AltModeText:SetText(SGPLocal.AltModeText);
		
		local AltModeDescription = AltsContentPanel:CreateFontString(nil, "ARTWORK", "GameFontHighlightSmall");
		AltModeDescription:SetPoint("TOPLEFT", SGPFrameStuff.AltContentX+5, SGPFrameStuff.AltModeDescriptionY);
		AltModeDescription:SetText(SGPLocal.AltModeDescription);
		
		local AltModeButton = SGP_CreateDropDownButton("AltModeButton", AltsContentPanel, "TOPLEFT", 180, SGPFrameStuff.AltContentX3, SGPFrameStuff.AltModeButtonY, SGPLocal.AltModeButtonItems, SGPLocal.AltModeButtonTooltips);
		
		local Ranks = { };
		for i,v in pairs(SGP.Settings.GuildRanks) do
			if ( i > 1 ) then
				table.insert(Ranks, v.RankName);
			end
		end
		local AltRankButton = SGP_CreateDropDownButton("AltRankButton", AltsContentPanel, "TOPLEFT", 130, SGPFrameStuff.AltContentX4, SGPFrameStuff.AltModeButtonY, Ranks, nil);
		
		-- Filters Scroll and Content Frames
		
		local FiltersPanel = CreateFrame("FRAME","SGP_FiltersFrame");
		FiltersPanel.name = SGPLocal.FiltersPanelName;
		FiltersPanel.parent = ConfigPanel.name
		InterfaceOptions_AddCategory(FiltersPanel);
		
		local FiltersScrollFrame = CreateFrame("ScrollFrame", nil, FiltersPanel);
		FiltersScrollFrame:SetPoint("TOPLEFT", SGPFrameStuff.ScrollFrameX, SGPFrameStuff.ScrollFrameY);
		FiltersScrollFrame:SetPoint("BOTTOMRIGHT", SGPFrameStuff.ScrollFrameY, SGPFrameStuff.ScrollFrameX);
		FiltersPanel.scrollframe = FiltersScrollFrame;
		
		local FiltersScrollBar = CreateFrame("Slider", nil, FiltersScrollFrame, "UIPanelScrollBarTemplate");
		FiltersScrollBar:SetPoint("TOPLEFT", FiltersPanel, "TOPRIGHT", -21, -22);
		FiltersScrollBar:SetPoint("BOTTOMLEFT", FiltersPanel, "BOTTOMRIGHT", -21, 21);
		local FiltersScrollBarMax = 1;
		FiltersScrollBar:SetMinMaxValues(1, FiltersScrollBarMax);
		FiltersScrollBar:SetValueStep(1);
		FiltersScrollBar.scrollStep = 1;
		FiltersScrollBar:SetValue(0);
		FiltersScrollBar:SetWidth(16);
		FiltersScrollBar:SetScript("OnValueChanged", function (self, value)
													  self:GetParent():SetVerticalScroll(value)
												  end);
		local FiltersScrollBarTexture = FiltersScrollBar:CreateTexture(nil, "BACKGROUND");
		FiltersScrollBarTexture:SetAllPoints(FiltersScrollBar);
		FiltersScrollBarTexture:SetTexture(0, 0, 0, 0.4);
		FiltersPanel.FiltersScrollBar = FiltersScrollFrame;
		
		FiltersScrollFrame:EnableMouseWheel(true);
		FiltersScrollFrame:SetScript("OnMouseWheel", function(self, delta)
														if delta == 1 then
															if IsShiftKeyDown() then
																FiltersScrollBar:SetValue(1);
															else
																if (FiltersScrollBar:GetValue() - SGPFrameStuff.ScrollFrameStep < 1) then
																	FiltersScrollBar:SetValue(1);
																else
																	FiltersScrollBar:SetValue(FiltersScrollBar:GetValue()-SGPFrameStuff.ScrollFrameStep);
																end
															end
														else
															if IsShiftKeyDown() then
																FiltersScrollBar:SetValue(FiltersScrollBarMax);
															else
																if (FiltersScrollBar:GetValue() + SGPFrameStuff.ScrollFrameStep > FiltersScrollBarMax) then
																	FiltersScrollBar:SetValue(FiltersScrollBarMax);
																else
																	FiltersScrollBar:SetValue(FiltersScrollBar:GetValue()+SGPFrameStuff.ScrollFrameStep);
																end
															end
														end
													end);
		
		local FiltersContentPanel = CreateFrame("Frame", nil, FiltersScrollFrame);
		FiltersContentPanel:SetSize(200, 200);
		FiltersScrollFrame.content = FiltersContentPanel;
		
		FiltersScrollFrame:SetScrollChild(FiltersContentPanel);
		
		-- Stuff to put into Content Pane.
		
		local FilterManagementHeader = FiltersContentPanel:CreateFontString(nil, "ARTWORK", "GameFontGreenLarge");
		FilterManagementHeader:SetPoint("TOPLEFT", SGPFrameStuff.FilterHeaderX, SGPFrameStuff.FilterManagementHeaderY);
		FilterManagementHeader:SetText(SGPLocal.FilterManagementHeader);
		
		-- DoNotPromote Filter
		local FilterDoNotPromoteText = FiltersContentPanel:CreateFontString(nil, "ARTWORK", "GameFontNormal");
		FilterDoNotPromoteText:SetPoint("TOPLEFT", SGPFrameStuff.FilterContentX, SGPFrameStuff.FilterDoNotPromoteTextY);
		FilterDoNotPromoteText:SetText(SGPLocal.FilterDoNotPromoteText);
		
		local FilterDoNotPromoteDescription = FiltersContentPanel:CreateFontString(nil, "ARTWORK", "GameFontHighlightSmall");
		FilterDoNotPromoteDescription:SetPoint("TOPLEFT", SGPFrameStuff.FilterContentX+5, SGPFrameStuff.FilterDoNotPromoteDescriptionY);
		FilterDoNotPromoteDescription:SetText(SGPLocal.FilterDoNotPromoteDescription);
		FilterDoNotPromoteDescription:SetJustifyH("LEFT");
		
		local FilterDoNotPromoteButton = SGP_CreateDropDownButton("FilterDoNotPromoteButton", FiltersContentPanel, "TOPLEFT", 180, SGPFrameStuff.FilterContentX3, SGPFrameStuff.FilterDoNotPromoteButtonY, SGPLocal.FilterDoNotPromoteButtonItems, SGPLocal.FilterDoNotPromoteButtonTooltips);
		local FilterDoNotPromoteEditbox = SGP_CreateEditbox("FilterDoNotPromoteEditbox", FiltersContentPanel, 170, 20, SGPFrameStuff.FilterContentX4, SGPFrameStuff.FilterDoNotPromoteButtonY-4, SGPLocal.FilterDoNotPromoteEditbox);
		
		-- DoNotDemote Filter
		local FilterDoNotDemoteText = FiltersContentPanel:CreateFontString(nil, "ARTWORK", "GameFontNormal");
		FilterDoNotDemoteText:SetPoint("TOPLEFT", SGPFrameStuff.FilterContentX, SGPFrameStuff.FilterDoNotDemoteTextY);
		FilterDoNotDemoteText:SetText(SGPLocal.FilterDoNotDemoteText);
		
		local FilterDoNotDemoteDescription = FiltersContentPanel:CreateFontString(nil, "ARTWORK", "GameFontHighlightSmall");
		FilterDoNotDemoteDescription:SetPoint("TOPLEFT", SGPFrameStuff.FilterContentX+5, SGPFrameStuff.FilterDoNotDemoteDescriptionY);
		FilterDoNotDemoteDescription:SetText(SGPLocal.FilterDoNotDemoteDescription);
		FilterDoNotDemoteDescription:SetJustifyH("LEFT");
		
		local FilterDoNotDemoteButton = SGP_CreateDropDownButton("FilterDoNotDemoteButton", FiltersContentPanel, "TOPLEFT", 180, SGPFrameStuff.FilterContentX3, SGPFrameStuff.FilterDoNotDemoteButtonY, SGPLocal.FilterDoNotDemoteButtonItems, SGPLocal.FilterDoNotDemoteButtonTooltips);
		local FilterDoNotDemoteEditbox = SGP_CreateEditbox("FilterDoNotDemoteEditbox", FiltersContentPanel, 170, 20, SGPFrameStuff.FilterContentX4, SGPFrameStuff.FilterDoNotDemoteButtonY-4, SGPLocal.FilterDoNotDemoteEditbox);
		
		-- DoNotList Filter
		local FilterDoNotListText = FiltersContentPanel:CreateFontString(nil, "ARTWORK", "GameFontNormal");
		FilterDoNotListText:SetPoint("TOPLEFT", SGPFrameStuff.FilterContentX, SGPFrameStuff.FilterDoNotListTextY);
		FilterDoNotListText:SetText(SGPLocal.FilterDoNotListText);
		
		local FilterDoNotListDescription = FiltersContentPanel:CreateFontString(nil, "ARTWORK", "GameFontHighlightSmall");
		FilterDoNotListDescription:SetPoint("TOPLEFT", SGPFrameStuff.FilterContentX+5, SGPFrameStuff.FilterDoNotListDescriptionY);
		FilterDoNotListDescription:SetText(SGPLocal.FilterDoNotListDescription);
		FilterDoNotListDescription:SetJustifyH("LEFT");
		
		local FilterDoNotListButton = SGP_CreateDropDownButton("FilterDoNotListButton", FiltersContentPanel, "TOPLEFT", 180, SGPFrameStuff.FilterContentX3, SGPFrameStuff.FilterDoNotListButtonY, SGPLocal.FilterDoNotListButtonItems, SGPLocal.FilterDoNotListButtonTooltips);
		local FilterDoNotListEditbox = SGP_CreateEditbox("FilterDoNotListEditbox", FiltersContentPanel, 170, 20, SGPFrameStuff.FilterContentX4, SGPFrameStuff.FilterDoNotListButtonY-4, SGPLocal.FilterDoNotListEditbox);
		
		
		-- Main UI.
		
		local UI = CreateFrame("Frame", "UIFrame", UIParent);
		UI:SetMovable(true);
		UI:EnableMouse(true);
		UI:RegisterForDrag("LeftButton")
		UI:SetScript("OnDragStart", UI.StartMoving)
		UI:SetScript("OnDragStop", UI.StopMovingOrSizing)
		UI:SetSize(SGPFrameStuff.UIWidth, SGPFrameStuff.UIHeight);
		UI:SetPoint("CENTER", 0, 0);
		--[[local UITexture = UI:CreateTexture("ARTWORK");
		UITexture:SetAllPoints();
		UITexture:SetTexture(0, 0, 0, 0.6);]]
		UI:SetBackdrop({bgFile = "Interface\\ChatFrame\\ChatFrameBackground", 
									edgeFile = "Interface\\DialogFrame\\UI-DialogBox-Border", 
									tile = true,
									tileSize = 4,
									edgeSize = 16,
									insets = { 10, 10, 10, 10}})
		UI:SetBackdropColor(0.1,0.1,0.1,0.9)
		UI:SetBackdropBorderColor(1,1,1,0.5)
		
		local UIHeader = UI:CreateFontString(nil, "ARTWORK", "GameFontNormalLarge");
		UIHeader:SetPoint("TOP", UI, "TOP", SGPFrameStuff.UIX, SGPFrameStuff.UIHeaderY);
		UIHeader:SetText(SGPLocal.SGPLong);
		
		local UIFindButton = SGP_CreateButton("UIFindButton", UI, "TOP", 180, 30, SGPLocal.UIFindButton, SGPFrameStuff.UIX, SGPFrameStuff.UIFindButtonY);
		local UIBothButton = SGP_CreateButton("UIBothButton", UI, "TOP", 180, 30, SGPLocal.UIBothButton, SGPFrameStuff.UIX, SGPFrameStuff.UIBothButtonY);
		local UIPromoteButton = SGP_CreateButton("UIPromoteButton", UI, "TOP", 180, 30, SGPLocal.UIPromoteButton .. ": 0", SGPFrameStuff.UIX, SGPFrameStuff.UIPromoteButtonY);
		local UIDemoteButton = SGP_CreateButton("UIDemoteButton", UI, "TOP", 180, 30, SGPLocal.UIDemoteButton .. ": 0", SGPFrameStuff.UIX, SGPFrameStuff.UIDemoteButtonY);
		local UISettingsButton = SGP_CreateButton("UISettingsButton", UI, "TOP", 180, 30, SGPLocal.UISettingsButton, SGPFrameStuff.UIX, SGPFrameStuff.UISettingsButtonY);
		
		local UIClose = CreateFrame("Button", nil, UIFrame, "UIPanelCloseButton");
		UIClose:SetPoint("TOPRIGHT", UIFrame, "TOPRIGHT", -4, -4);
		
		SGPFrameStuff.UIFRAME = UIFrame;
		UIFrame:Hide();
		
		-- Promote List Frame
		local UIPromoteList = CreateFrame("Frame", "UIPromoteList", UI);
		UIPromoteList:SetSize(SGPFrameStuff.UIListWidth, SGPFrameStuff.UIHeight);
		UIPromoteList:SetPoint("TOPLEFT", UI, "TOPLEFT", (0 - SGPFrameStuff.UIListWidth - SGPFrameStuff.UIPadding), 0);
		--[[local UIPromoteListTexture = UI:CreateTexture("ARTWORK");
		UIPromoteListTexture:SetAllPoints();
		UIPromoteListTexture:SetTexture(0, 0, 0, 0.6);]]
		UIPromoteList:SetBackdrop({bgFile = "Interface\\ChatFrame\\ChatFrameBackground", 
									edgeFile = "Interface\\DialogFrame\\UI-DialogBox-Border", 
									tile = true,
									tileSize = 4,
									edgeSize = 16,
									insets = { 10, 10, 10, 10}})
		UIPromoteList:SetBackdropColor(0.1,0.1,0.1,0.9)
		UIPromoteList:SetBackdropBorderColor(1,1,1,0.5)
		
		local UIPromoteListClose = CreateFrame("Button", nil, UIPromoteList, "UIPanelCloseButton");
		UIPromoteListClose:SetPoint("TOPRIGHT", UIPromoteList, "TOPRIGHT", -4, -4);
		
		local UIPromoteScrollingFrameText = UIPromoteList:CreateFontString(nil, "ARTWORK", "GameFontNormal");
		UIPromoteScrollingFrameText:SetPoint("CENTER", UIPromoteList, "TOP", SGPFrameStuff.PromoteListX, SGPFrameStuff.PromoteListTextY);
		UIPromoteScrollingFrameText:SetText(SGPLocal.PromoteList);
		
		local UIPromoteScrollingFrame = SGP_CreateScrollingMessageFrame("SGPListFramePromote", UIPromoteList, "TOP", (SGPFrameStuff.UIListWidth - 30), (SGPFrameStuff.UIHeight - 55), SGPFrameStuff.PromoteListX, SGPFrameStuff.PromoteListY);
		
		SGPFrameStuff.PROMOTELISTFRAME = UIPromoteList;
		SGPFrameStuff.PROMOTELISTFRAME:Hide();
		
		-- Demote List Frame
		local UIDemoteList = CreateFrame("Frame", "UIDemoteList", UI);
		UIDemoteList:SetSize(SGPFrameStuff.UIListWidth, SGPFrameStuff.UIHeight);
		UIDemoteList:SetPoint("TOPLEFT", UI, "TOPRIGHT", SGPFrameStuff.UIPadding, 0);
		--[[local UIDemoteListTexture = UI:CreateTexture("ARTWORK");
		UIDemoteListTexture:SetAllPoints();
		UIDemoteListTexture:SetTexture(0, 0, 0, 0.6);]]
		UIDemoteList:SetBackdrop({bgFile = "Interface\\ChatFrame\\ChatFrameBackground", 
									edgeFile = "Interface\\DialogFrame\\UI-DialogBox-Border", 
									tile = true,
									tileSize = 4,
									edgeSize = 16,
									insets = { 10, 10, 10, 10}})
		UIDemoteList:SetBackdropColor(0.1,0.1,0.1,0.9)
		UIDemoteList:SetBackdropBorderColor(1,1,1,0.5)
		
		local UIDemoteListClose = CreateFrame("Button", nil, UIDemoteList, "UIPanelCloseButton");
		UIDemoteListClose:SetPoint("TOPRIGHT", UIDemoteList, "TOPRIGHT", -4, -4);
		
		local UIDemoteScrollingFrameText = UIDemoteList:CreateFontString(nil, "ARTWORK", "GameFontNormal");
		UIDemoteScrollingFrameText:SetPoint("CENTER", UIDemoteList, "TOP", SGPFrameStuff.DemoteListX, SGPFrameStuff.DemoteListTextY);
		UIDemoteScrollingFrameText:SetText(SGPLocal.DemoteList);
		
		local UIDemoteScrollingFrame = SGP_CreateScrollingMessageFrame("SGPListFrameDemote", UIDemoteList, "TOP", (SGPFrameStuff.UIListWidth - 30), (SGPFrameStuff.UIHeight - 55), SGPFrameStuff.DemoteListX, SGPFrameStuff.DemoteListY);
		
		SGPFrameStuff.DEMOTELISTFRAME = UIDemoteList;
		SGPFrameStuff.DEMOTELISTFRAME:Hide();
		
		-- Now make sure every element has the value it should based on current settings.
		SGP_FillRenderedOptionsWithSaveData();
		SGP_SaveSettings();
		SGP_ChatEcho("Swyn's Guild Promoter loaded. Type /sgp for a list of commands.")
	end
	
end

function SGP_FillRenderedOptionsWithSaveData()
	SGP_DebugEcho("Filling elements to match current settings.");
	
	-- Ranks Stuff
	for i,v in pairs(SGP.Settings.GuildRanks) do
		if (i > 1) then
			SGPFrameStuff.CHECKBOXES["Attainable"..v.RankName]:SetChecked(v.Attainable);
			SGPFrameStuff.CHECKBOXES["AllowPromote"..v.RankName]:SetChecked(v.AllowPromote);
			SGPFrameStuff.CHECKBOXES["AllowDemote"..v.RankName]:SetChecked(v.AllowDemote);
			SGPFrameStuff.EDITBOXES["MinTotalXP"..v.RankName]:SetNumber(v.TotalXP);
			SGPFrameStuff.EDITBOXES["MinWeeklyXP"..v.RankName]:SetNumber(v.WeeklyXP);
			SGPFrameStuff.EDITBOXES["MinLevel"..v.RankName]:SetNumber(v.Level);
			SGPFrameStuff.EDITBOXES["MinAchievement"..v.RankName]:SetNumber(v.Achievement);
			-- Updating Dropdown Menu's requires opening them first, so they can be read.
			ToggleDropDownMenu(1, nil, SGPFrameStuff.DROPDOWNS["MinReputation"..v.RankName]);
			UIDropDownMenu_SetSelectedID(SGPFrameStuff.DROPDOWNS["MinReputation"..v.RankName], v.Reputation-3); -- -3 to Offset that in the DDM, Neutral is 1 and in the FACTION_STANDING_LABEL, Neutral is 4.
			ToggleDropDownMenu(1, nil, SGPFrameStuff.DROPDOWNS["MinReputation"..v.RankName]);
		end
	end
			
	-- Alts Stuff
	-- Updating Dropdown Menu's requires opening them first, so they can be read.
	ToggleDropDownMenu(1, nil, SGPFrameStuff.DROPDOWNS["AltNoteButton"]);
	UIDropDownMenu_SetSelectedID(SGPFrameStuff.DROPDOWNS["AltNoteButton"], SGP.Settings.AltNote);
	ToggleDropDownMenu(1, nil, SGPFrameStuff.DROPDOWNS["AltNoteButton"]);
	
	ToggleDropDownMenu(1, nil, SGPFrameStuff.DROPDOWNS["AltModeButton"]);
	UIDropDownMenu_SetSelectedID(SGPFrameStuff.DROPDOWNS["AltModeButton"], SGP.Settings.AltMode);
	ToggleDropDownMenu(1, nil, SGPFrameStuff.DROPDOWNS["AltModeButton"]);
	
	ToggleDropDownMenu(1, nil, SGPFrameStuff.DROPDOWNS["AltRankButton"]);
	UIDropDownMenu_SetSelectedID(SGPFrameStuff.DROPDOWNS["AltRankButton"], SGP.Settings.AltRank);
	ToggleDropDownMenu(1, nil, SGPFrameStuff.DROPDOWNS["AltRankButton"]);
	if ( SGP.Settings.AltMode == 1 or SGP.Settings.AltMode == 3 or SGP.Settings.AltMode == 4 ) then
		SGPFrameStuff.DROPDOWNS["AltRankButton"]:Hide();
	else
		SGPFrameStuff.DROPDOWNS["AltRankButton"]:Show();
	end
	
	-- Filters Stuff
	-- Updating Dropdown Menu's requires opening them first, so they can be read.
	ToggleDropDownMenu(1, nil, SGPFrameStuff.DROPDOWNS["FilterDoNotPromoteButton"]);
	UIDropDownMenu_SetSelectedID(SGPFrameStuff.DROPDOWNS["FilterDoNotPromoteButton"], SGP.Settings.FilterDNP);
	ToggleDropDownMenu(1, nil, SGPFrameStuff.DROPDOWNS["FilterDoNotPromoteButton"]);
	SGPFrameStuff.EDITBOXES["FilterDoNotPromoteEditbox"]:SetText(SGP.Settings.FilterDNPText);
	if ( SGP.Settings.FilterDNP == 1 ) then
		SGPFrameStuff.EDITBOXES["FilterDoNotPromoteEditbox"]:Hide();
	else
		SGPFrameStuff.EDITBOXES["FilterDoNotPromoteEditbox"]:Show();
	end
	
	ToggleDropDownMenu(1, nil, SGPFrameStuff.DROPDOWNS["FilterDoNotDemoteButton"]);
	UIDropDownMenu_SetSelectedID(SGPFrameStuff.DROPDOWNS["FilterDoNotDemoteButton"], SGP.Settings.FilterDND);
	ToggleDropDownMenu(1, nil, SGPFrameStuff.DROPDOWNS["FilterDoNotDemoteButton"]);
	SGPFrameStuff.EDITBOXES["FilterDoNotDemoteEditbox"]:SetText(SGP.Settings.FilterDNDText);
	if ( SGP.Settings.FilterDND == 1 ) then
		SGPFrameStuff.EDITBOXES["FilterDoNotDemoteEditbox"]:Hide();
	else
		SGPFrameStuff.EDITBOXES["FilterDoNotDemoteEditbox"]:Show();
	end
	
	ToggleDropDownMenu(1, nil, SGPFrameStuff.DROPDOWNS["FilterDoNotListButton"]);
	UIDropDownMenu_SetSelectedID(SGPFrameStuff.DROPDOWNS["FilterDoNotListButton"], SGP.Settings.FilterDNL);
	ToggleDropDownMenu(1, nil, SGPFrameStuff.DROPDOWNS["FilterDoNotListButton"]);
	SGPFrameStuff.EDITBOXES["FilterDoNotListEditbox"]:SetText(SGP.Settings.FilterDNLText);
	if ( SGP.Settings.FilterDNL == 1 ) then
		SGPFrameStuff.EDITBOXES["FilterDoNotListEditbox"]:Hide();
	else
		SGPFrameStuff.EDITBOXES["FilterDoNotListEditbox"]:Show();
	end
end

function UpdateSettings()
	SGP_DebugEcho("Updating current settings to reflect elements.");
	
	-- Ranks Stuff
	for i,v in pairs(SGP.Settings.GuildRanks) do
		if (i > 1) then
			v.Attainable = SGPFrameStuff.CHECKBOXES["Attainable"..v.RankName]:GetChecked();
			v.AllowPromote = SGPFrameStuff.CHECKBOXES["AllowPromote"..v.RankName]:GetChecked();
			v.AllowDemote = SGPFrameStuff.CHECKBOXES["AllowDemote"..v.RankName]:GetChecked();
			v.TotalXP = SGPFrameStuff.EDITBOXES["MinTotalXP"..v.RankName]:GetNumber();
			v.WeeklyXP = SGPFrameStuff.EDITBOXES["MinWeeklyXP"..v.RankName]:GetNumber();
			v.Level = SGPFrameStuff.EDITBOXES["MinLevel"..v.RankName]:GetNumber();
			v.Achievement = SGPFrameStuff.EDITBOXES["MinAchievement"..v.RankName]:GetNumber();
			-- Updating Dropdown Menu's requires opening them first, so they can be read.
			ToggleDropDownMenu(1, nil, SGPFrameStuff.DROPDOWNS["MinReputation"..v.RankName]);
			v.Reputation = UIDropDownMenu_GetSelectedID(SGPFrameStuff.DROPDOWNS["MinReputation"..v.RankName])+3; -- +3 to Offset that in the DDM, Neutral is 1 and in the FACTION_STANDING_LABEL, Neutral is 4.
			ToggleDropDownMenu(1, nil, SGPFrameStuff.DROPDOWNS["MinReputation"..v.RankName]);
		end
	end
	
	-- Alts Stuff
	-- Updating Dropdown Menu's requires opening them first, so they can be read.
	ToggleDropDownMenu(1, nil, SGPFrameStuff.DROPDOWNS["AltNoteButton"]);
	SGP.Settings.AltNote = UIDropDownMenu_GetSelectedID(SGPFrameStuff.DROPDOWNS["AltNoteButton"]);
	ToggleDropDownMenu(1, nil, SGPFrameStuff.DROPDOWNS["AltNoteButton"]);
	
	ToggleDropDownMenu(1, nil, SGPFrameStuff.DROPDOWNS["AltModeButton"]);
	SGP.Settings.AltMode = UIDropDownMenu_GetSelectedID(SGPFrameStuff.DROPDOWNS["AltModeButton"]);
	ToggleDropDownMenu(1, nil, SGPFrameStuff.DROPDOWNS["AltModeButton"]);
	
	ToggleDropDownMenu(1, nil, SGPFrameStuff.DROPDOWNS["AltRankButton"]);
	SGP.Settings.AltRank = UIDropDownMenu_GetSelectedID(SGPFrameStuff.DROPDOWNS["AltRankButton"]);
	ToggleDropDownMenu(1, nil, SGPFrameStuff.DROPDOWNS["AltRankButton"]);
	if ( SGP.Settings.AltMode == 1 or SGP.Settings.AltMode == 3 or SGP.Settings.AltMode == 4 ) then
		SGPFrameStuff.DROPDOWNS["AltRankButton"]:Hide();
	else
		SGPFrameStuff.DROPDOWNS["AltRankButton"]:Show();
	end
	
	-- Filters Stuff
	-- Updating Dropdown Menu's requires opening them first, so they can be read.
	ToggleDropDownMenu(1, nil, SGPFrameStuff.DROPDOWNS["FilterDoNotPromoteButton"]);
	SGP.Settings.FilterDNP = UIDropDownMenu_GetSelectedID(SGPFrameStuff.DROPDOWNS["FilterDoNotPromoteButton"]);
	ToggleDropDownMenu(1, nil, SGPFrameStuff.DROPDOWNS["FilterDoNotPromoteButton"]);
	SGP.Settings.FilterDNPText = SGPFrameStuff.EDITBOXES["FilterDoNotPromoteEditbox"]:GetText();
	if ( SGP.Settings.FilterDNP == 1 ) then
		SGPFrameStuff.EDITBOXES["FilterDoNotPromoteEditbox"]:Hide();
	else
		SGPFrameStuff.EDITBOXES["FilterDoNotPromoteEditbox"]:Show();
	end
	
	ToggleDropDownMenu(1, nil, SGPFrameStuff.DROPDOWNS["FilterDoNotDemoteButton"]);
	SGP.Settings.FilterDND = UIDropDownMenu_GetSelectedID(SGPFrameStuff.DROPDOWNS["FilterDoNotDemoteButton"]);
	ToggleDropDownMenu(1, nil, SGPFrameStuff.DROPDOWNS["FilterDoNotDemoteButton"]);
	SGP.Settings.FilterDNDText = SGPFrameStuff.EDITBOXES["FilterDoNotDemoteEditbox"]:GetText();
	if ( SGP.Settings.FilterDND == 1 ) then
		SGPFrameStuff.EDITBOXES["FilterDoNotDemoteEditbox"]:Hide();
	else
		SGPFrameStuff.EDITBOXES["FilterDoNotDemoteEditbox"]:Show();
	end
	
	ToggleDropDownMenu(1, nil, SGPFrameStuff.DROPDOWNS["FilterDoNotListButton"]);
	SGP.Settings.FilterDNL = UIDropDownMenu_GetSelectedID(SGPFrameStuff.DROPDOWNS["FilterDoNotListButton"]);
	ToggleDropDownMenu(1, nil, SGPFrameStuff.DROPDOWNS["FilterDoNotListButton"]);
	SGP.Settings.FilterDNLText = SGPFrameStuff.EDITBOXES["FilterDoNotListEditbox"]:GetText();
	if ( SGP.Settings.FilterDNL == 1 ) then
		SGPFrameStuff.EDITBOXES["FilterDoNotListEditbox"]:Hide();
	else
		SGPFrameStuff.EDITBOXES["FilterDoNotListEditbox"]:Show();
	end
	
	-- Save Settings once they've been updated.
	SGP_SaveSettings();
end

function SGP_CreateCheckbox(name, parent, text, offsetX, offsetY, tooltips)
	local cb = CreateFrame("CheckButton", name, parent, "ChatConfigCheckButtonTemplate");
	cb:SetPoint("TOPLEFT", parent, "TOPLEFT", offsetX, offsetY);
	if (tooltips ~= nil) then
		cb.tooltip = tooltips;
	end
	cb:SetScript("OnClick", function(self)
									   UpdateSettings();
								   end);
	
	local font = cb:CreateFontString("CheckFont"..name, "OVERLAY", "GameFontHighlightSmall");
	font:SetText(text);
	font:SetPoint("LEFT", cb, "RIGHT", 4, 1);
	
	SGPFrameStuff.CHECKBOXES[name] = cb;
end

function SGP_CreateEditbox(name, parent, width, height, offsetX, offsetY, tooltip)
	local eb = CreateFrame("EditBox", name, parent, "InputBoxTemplate");
	eb:SetPoint("TOPLEFT", parent, "TOPLEFT", offsetX, offsetY);
	if ( string.find(name, "MinLevel") ) then
		eb:SetMaxLetters(3);
	elseif ( string.find(name, "MinAchievement") ) then
		eb:SetMaxLetters(7);
	else
		eb:SetMaxLetters(22);
	end
	eb:SetWidth(width);
	eb:SetHeight(height);
	eb:SetAutoFocus(false);
	if (tooltip ~= nil) then
		eb.tooltip = tooltip;
	end
	eb:SetScript("OnEnterPressed", function(self)
									   eb:SetCursorPosition(0);
									   eb:ClearFocus();
								   end);
	eb:SetScript("OnEditFocusLost", function(self)
										UpdateSettings();
									    eb:SetCursorPosition(0);
									    eb:ClearFocus();
								    end);
	eb:SetScript("OnTextSet", function(self)
								  eb:SetCursorPosition(0);
								  eb:ClearFocus();
							  end);
	if ( not string.find(name, "Filter") ) then
		eb:SetNumeric();
		eb:Insert(0);
	else
		eb:SetText("");
	end
	eb:SetCursorPosition(0);
	eb:ClearFocus();
	
	SGPFrameStuff.EDITBOXES[name] = eb;
end

function SGP_CreateDropDownButton(name, parent, pos, width, offsetX, offsetY, items, tooltips)
	local ddm = CreateFrame("Button", name, parent, "UIDropDownMenuTemplate");

	ddm:ClearAllPoints();
	ddm:SetPoint(pos, parent, pos, offsetX, offsetY);
	ddm:Show();
	
	local function OnClick(self)
		UIDropDownMenu_SetSelectedID(ddm, self:GetID());
		UpdateSettings();
	end
	
	local function initialize(self, level)
		local info = UIDropDownMenu_CreateInfo();
		for k,v in pairs(items) do
			info = UIDropDownMenu_CreateInfo();
			info.text = v;
			info.value = v;
			info.func = OnClick;
			if (tooltips ~= nil) then
				info.tooltipOnButton = true;
				info.tooltipTitle = v;
				info.tooltipText = tooltips[k];
			end
			UIDropDownMenu_AddButton(info, level);
		end
	end

	UIDropDownMenu_Initialize(ddm, initialize);
	UIDropDownMenu_SetWidth(ddm, width-24);
	UIDropDownMenu_SetButtonWidth(ddm, width);
	UIDropDownMenu_JustifyText(ddm, "LEFT");
	
	UIDropDownMenu_SetSelectedID(ddm, 1);
					
	SGPFrameStuff.DROPDOWNS[name] = ddm;
	
end

function SGP_CreateButton(name, parent, pos, width, height, text, offsetX, offsetY)
	local b = CreateFrame("Button", name, parent, "UIPanelButtonTemplate");
	b:SetWidth(width);
	b:SetHeight(height);
	b:SetPoint(pos, parent, pos, offsetX, offsetY);
	
	-- Find
	if name == "UIFindButton" then
		b:SetScript("OnClick", SGP_Find);
	end
	-- Promote and Demote
	if name == "UIBothButton" then
		b:SetScript("OnClick", function()
						SGP_Promote();
						SGP_Demote();
					end);
	end
	-- Promote
	if name == "UIPromoteButton" then
		b:SetScript("OnClick", SGP_Promote);
	end
	-- Demote
	if name == "UIDemoteButton" then
		b:SetScript("OnClick", SGP_Demote);
	end
	-- Filters
	if name == "UISettingsButton" then
		b:SetScript("OnClick", function()
								   InterfaceOptionsFrame_OpenToCategory(SGPLocal.SGPShort);
							   end);
	end
	
	local font = b:CreateFontString(nil,"OVERLAY","GameFontHighlight");
	font:SetText(text);
	font:SetPoint("CENTER");
	
	SGPFrameStuff.BUTTONS[name] = b;
	SGPFrameStuff.BUTTONTEXTS[name] = font;
end

function SGP_CreateScrollingMessageFrame(name, parent, pos, width, height, topOffsetX, topOffsetY)
	local smf = CreateFrame("ScrollingMessageFrame", name, parent);
	smf:SetPoint(pos, parent, pos, topOffsetX, topOffsetY-3);
	smf:SetWidth(width-6);
	smf:SetHeight(height-6);
	smf:SetMaxLines(1000);
	smf:SetFading(false);
	smf:SetJustifyH("LEFT");
	smf:SetFontObject("GameFontHighlightSmall");
	smf:SetIndentedWordWrap(true);
	smf:SetInsertMode("TOP");
	smf:SetScript("OnMouseWheel", function(self, delta)
		if delta == 1 then
			if IsShiftKeyDown() then
				smf:ScrollToTop();
			else
				smf:ScrollUp();
			end
		else
			if IsShiftKeyDown() then
				smf:ScrollToBottom();
			else
				smf:ScrollDown();
			end
		end
		end);
		
	
	smf:SetBackdrop({bgFile = "Interface\\ChatFrame\\ChatFrameBackground", 
								tile = true,
								tileSize = 2});
	smf:SetBackdropColor(0.0,0.0,0.0,0.8);
		
	SGPFrameStuff.LISTS[name] = smf;
end

SLASH_SGP1 = '/sgp';
function SlashCmdList.SGP(msg, editbox)
	if msg == 'show' then
		SGPFrameStuff.UIFRAME:Show();
	elseif msg == 'hide' then
		SGPFrameStuff.UIFRAME:Hide();
	elseif msg == 'settings' then
		InterfaceOptionsFrame_OpenToCategory(SGPLocal.SGPShort);
	else
		SGP_ChatEcho("Slash commands are:");
		SGP_ChatEcho("  |cffEFE327show|r - Shows the UI.");
		SGP_ChatEcho("  |cffEFE327hide|r - Hides the UI.");
		SGP_ChatEcho("  |cffEFE327settings|r - Opens the Settings UI.");
	end
end

function SGP_ClearLists(msg)
	if (msg == "All" or msg == "Promote") then
		ClearTable(SGP.PromoteList);
		SGPFrameStuff.LISTS["SGPListFramePromote"]:Clear();
	end
	if (msg == "All" or msg == "Demote") then
		ClearTable(SGP.DemoteList);
		SGPFrameStuff.LISTS["SGPListFrameDemote"]:Clear();
	end
	if (table.getn(SGP.PromoteList) == 0) then
		SGPFrameStuff.PROMOTELISTFRAME:Hide();
	end
	if (table.getn(SGP.DemoteList) == 0) then
		SGPFrameStuff.DEMOTELISTFRAME:Hide();
	end
end

function ClearTable(TABLE)
	for i,v in pairs(TABLE) do
		TABLE[i] = nil;
	end
end

function SGP_ShowLists()
	local members = SGP.Settings.MemberList;
	local membersTally = SGP.Settings.MemberTallyList;

	-- At present this only shows the main name if it exists even though the promote/demote will handle arbitrary main names
	for i,v in pairs(SGPFrameStuff.LISTS) do
		if (v:GetName() == "SGPListFramePromote") then
			for k,x in pairs(SGP.PromoteList) do
				if ( not (SGP_IsWordInString(SGP.Settings.FilterDNLText, x.Note) and (SGP.Settings.FilterDNL == 2 or SGP.Settings.FilterDNL == 4)) and
					 not (SGP_IsWordInString(SGP.Settings.FilterDNLText, x.OfficerNote) and (SGP.Settings.FilterDNL == 3 or SGP.Settings.FilterDNL == 4)) ) then
					 -- AltText starts as empty.
					local altText = "";
					-- If we have a main, use that as AltText.
					local main = SGP_MainName(x.Name, x.Note, x.OfficerNote);
					local mainIndex = SGP_NameIndex(SGP.Settings.MemberTallyList, main);
					if (mainIndex ~= nil and x.Name ~= SGP.Settings.MemberTallyList[mainIndex].Name) then
						altText = "|cffFA06B8(|r|c" .. SGP_GetClassColour(SGP.Settings.MemberTallyList[mainIndex].Name) .. SGP.Settings.MemberTallyList[mainIndex].Name .. "|r|cffFA06B8)|r ";
					end
					v:AddMessage("|c" .. SGP_GetClassColour(x.ClassFileName) .. x.Name .. "|r " .. altText .. "|cffFFFFFF" .. x.Rank .. "|r |cffFA06B8>|r |cffFFFFFF" .. GuildControlGetRankName(x.NewRankIndex) .. "|r");
				end
			end
		elseif (v:GetName() == "SGPListFrameDemote") then
			for l,y in pairs(SGP.DemoteList) do
				if ( not (SGP_IsWordInString(SGP.Settings.FilterDNLText, y.Note) and (SGP.Settings.FilterDNL == 2 or SGP.Settings.FilterDNL == 4)) and
					 not (SGP_IsWordInString(SGP.Settings.FilterDNLText, y.OfficerNote) and (SGP.Settings.FilterDNL == 3 or SGP.Settings.FilterDNL == 4)) ) then
					 -- AltText starts as empty.
					local altText = "";
					-- If we have a main, use that as AltText.
					local main = SGP_MainName(y.Name, y.Note, y.OfficerNote);
					local mainIndex = SGP_NameIndex(SGP.Settings.MemberTallyList, main);
					if (mainIndex ~= nil and y.Name ~= SGP.Settings.MemberTallyList[mainIndex].Name) then
						altText = "|cffFA06B8(|r|c" .. SGP_GetClassColour(SGP.Settings.MemberTallyList[mainIndex].Name) .. SGP.Settings.MemberTallyList[mainIndex].Name .. "|r|cffFA06B8)|r ";
					end
					v:AddMessage("|c" .. SGP_GetClassColour(y.ClassFileName) .. y.Name .. "|r " .. altText .. "|cffFFFFFF" .. y.Rank .. "|r |cffFA06B8>|r |cffFFFFFF" .. GuildControlGetRankName(y.NewRankIndex) .. "|r");
				end
			end
		end
	end
	-- If PromoteList has people in it, and SGPListFramePromote has people in it, show it. (Just in case everyone in the list is DNL filtered)
	if (table.getn(SGP.PromoteList) > 0 and SGPFrameStuff.LISTS["SGPListFramePromote"]:GetCurrentLine() >= 0) then
		SGPFrameStuff.PROMOTELISTFRAME:Show();
	end
	-- If DemoteList has people in it, and SGPListFrameDemote has people in it, show it. (Just in case everyone in the list is DNL filtered)
	if (table.getn(SGP.DemoteList) > 0 and SGPFrameStuff.LISTS["SGPListFrameDemote"]:GetCurrentLine() >= 0) then
		SGPFrameStuff.DEMOTELISTFRAME:Show();
	end
end

function SGP_GetClassColour(name)
	if (name ~= nil) then
		-- If name is a ClassFileName, return the colour.
		if ( RAID_CLASS_COLORS[name] ~= nil ) then
			return RAID_CLASS_COLORS[name].colorStr;
		end
		-- Otherwise, we're probably a guildies name, so check the guild roster for anyone by that name.
		for i,v in pairs(SGP.Settings.MemberList) do
			if ( v.Name == name ) then
				return RAID_CLASS_COLORS[v.ClassFileName].colorStr;
			end
		end
	end
	-- If we're here then we're most likely an arbitrary name, in which case, return white.
	return "ff999999";
end

function SGP_IsWordInString(Word, String)
	if (String ~= nil and String ~= "") then
		for w in string.gmatch(String, "%w+") do
			if (w == Word) then
				return true;
			end
		end
	end
	return false;
end

function SGP_NameIndex(table, name)
	for i,v in pairs(table) do
		if( name == v.Name ) then
			return i;
		end
	end
	return nil;
end

-- returns a string with ALL instances of Match changed to Replace in String
function SGP_ReplaceWord(Match, Replace, String)
	return string.gsub( String, "%w+", function(s) if(s == Match) then return Replace end return s end );
end

function SGP_FirstWord(String)
	-- this should return just the first word of the words contained in String
	return string.match( String, "%w+" );
end

function SGP_MainName(name, note, officerNote)
	-- get the "main"'s name
	-- Note: For option 3, public note has preference over officer note
	local mainName = "";
	local str = "";
	local idx = 0;
	SGP_DebugEcho("SGP_MainName "..name..", note='"..note.."', onote='"..officerNote.."'");
	
	if (SGP.Settings.AltNote == 1 or SGP.Settings.AltNote == 3) then
		-- if this could contain the DND/DNP strings then remove those if they are present as whole words
		str = note;
		if( SGP.Settings.FilterDND == 2 or SGP.Settings.FilterDND == 4 ) then
			str = SGP_ReplaceWord(SGP.Settings.FilterDNDText, "", str);
		end
		if( SGP.Settings.FilterDNP == 2 or SGP.Settings.FilterDNP == 4 ) then
			str = SGP_ReplaceWord(SGP.Settings.FilterDNPText, "", str);
		end
		if( SGP.Settings.FilterDNL == 2 or SGP.Settings.FilterDNL == 4 ) then
			str = SGP_ReplaceWord(SGP.Settings.FilterDNLText, "", str);
		end
		mainName = SGP_FirstWord(str);
	end
	if (SGP.Settings.AltNote == 2 or (SGP.Settings.AltNote == 3 and (mainName == "" or mainName == nil))) then
		-- if this could contain the DND/DNP strings then remove those if they are present as whole words
		str = officerNote;
		if( ( SGP.Settings.FilterDND == 2 ) or ( SGP.Settings.FilterDND == 4 ) ) then
			str = SGP_ReplaceWord(SGP.Settings.FilterDNDText, "", str);
		end
		if( ( SGP.Settings.FilterDNP == 2 ) or ( SGP.Settings.FilterDNP == 4 ) ) then
			str = SGP_ReplaceWord(SGP.Settings.FilterDNPText, "", str);
		end
		if( ( SGP.Settings.FilterDNL == 2 ) or ( SGP.Settings.FilterDNL == 4 ) ) then
			str = SGP_ReplaceWord(SGP.Settings.FilterDNLText, "", str);
		end
		mainName = SGP_FirstWord(str);
	end
	-- fallback to character name
	if (mainName == "" or mainName == nil) then
		mainName = name;
	end
	return mainName;
end

--[[ STUFF THAT ACTUALLY DOES STUFF ]]--
function SGP_Find()
	SGP_DebugEcho("Finding people to promote or demote.");
	SGP_ClearLists("All");
	
	-- Up to date Guild Member Lists. One with everyone, one with only people with notes (smaller list so I can find alt's).
	local Members = { };
	local MembersTally = { };
	for i=1, GetNumGuildMembers() do
		local weeklyXP, totalXP = GetGuildRosterContribution(i);
		local name, rank, rankIndex, level, class, zone, note, 
			  officerNote, online, status, classFileName, 
			  achievementPoints, achievementRank, isMobile, canSoR, repStanding = GetGuildRosterInfo(i);
		local member = {
					Name = name;
					Class = class;
					ClassFileName = classFileName;
					Index = i;
					Rank = rank;
					RankIndex = rankIndex+1; -- rankIndex is 0 based index. GuildControlGetRankName is 1 based index. So add 1 to compensate.
					TotalXP = totalXP;
					WeeklyXP = weeklyXP;
					Level = level;
					Achievement = achievementPoints;
					Reputation = repStanding;
					Note = note;
					OfficerNote = officerNote;
					NewRankIndex = rankIndex+1;
				};
		table.insert(Members, member);
		
		-- find "main" in MemberSums - add it if needed
		-- add/sum into MemberSums: TotalXP, WeeklyXP.
	
		local nameTally = SGP_MainName(name, note, officerNote);
		
		local memberTally = {
					Name = nameTally;
					TotalXP = 0;
					WeeklyXP = 0;
					Level = 0;
					Achievement = 0;
					Reputation = 4;
				};
		
		mainIndex = SGP_NameIndex(MembersTally, nameTally);
			
		if mainIndex == nil then
			table.insert(MembersTally, memberTally);
			mainIndex = table.getn( MembersTally );
		end

		MembersTally[mainIndex].Name = nameTally;
		if ( SGP.Settings.AltMode == 4 ) then
			-- Combined Sum Total
			MembersTally[mainIndex].TotalXP = MembersTally[mainIndex].TotalXP + totalXP;
			MembersTally[mainIndex].WeeklyXP = MembersTally[mainIndex].WeeklyXP + weeklyXP;
			-- Don't Sum level, achievements or reputation, just use the highest one available.
			if ( MembersTally[mainIndex].Level < level ) then
				MembersTally[mainIndex].Level = level;
			end
			if ( MembersTally[mainIndex].Achievement < achievementPoints ) then
				MembersTally[mainIndex].Achievement = achievementPoints;
			end
			if ( MembersTally[mainIndex].Reputation < repStanding ) then
				MembersTally[mainIndex].Reputation = repStanding;
			end
		elseif ( SGP.Settings.AltMode == 3 ) then
			-- Combined Highest
			if ( MembersTally[mainIndex].TotalXP < totalXP ) then
				MembersTally[mainIndex].TotalXP = totalXP;
			end
			if ( MembersTally[mainIndex].WeeklyXP < weeklyXP ) then
				MembersTally[mainIndex].WeeklyXP = weeklyXP;
			end
			if ( MembersTally[mainIndex].Level < level ) then
				MembersTally[mainIndex].Level = level;
			end
			if ( MembersTally[mainIndex].Achievement < achievementPoints ) then
				MembersTally[mainIndex].Achievement = achievementPoints;
			end
			if ( MembersTally[mainIndex].Reputation < repStanding ) then
				MembersTally[mainIndex].Reputation = repStanding;
			end
		else
			MembersTally[mainIndex].TotalXP = totalXP;
			MembersTally[mainIndex].WeeklyXP = weeklyXP;
			MembersTally[mainIndex].Level = level;
			MembersTally[mainIndex].Achievement = achievementPoints;
			MembersTally[mainIndex].Reputation = repStanding;
		end
	end
	SGP.Settings.MemberList = Members;
	SGP.Settings.MemberTallyList = MembersTally;
	
	SGP_CalculateRankChanges(Members,MembersTally);
	
	SGPFrameStuff.BUTTONTEXTS["UIPromoteButton"]:SetText(SGPLocal.UIPromoteButton .. ": " .. table.getn(SGP.PromoteList));
	SGPFrameStuff.BUTTONTEXTS["UIDemoteButton"]:SetText(SGPLocal.UIDemoteButton .. ": " .. table.getn(SGP.DemoteList));
	
	SGP_ShowLists();
end

function SGP_CalculateRankChanges(MemberList,MemberTallyList)
	local PlayerGuildName, PlayerGuildRankName, PlayerGuildRankIndex = GetGuildInfo("player");
	PlayerGuildRankIndex = PlayerGuildRankIndex + 1; -- PlayerGuildRankIndex is 0 based index. GuildControlGetRankName is 1 based index. So add one to compensate.
	
	local Alts = { };
	
	-- Cycle through everyone.
	for i,v in pairs(MemberList) do
		-- Ignore if their rank is greater than or equal to the player's rank - because we wouldn't be able to mod their rank even if we wanted to.
		if (v.RankIndex > PlayerGuildRankIndex) then
			-- Check if Alt Contribution is on.
			local mainName = SGP_MainName(v.Name, v.Note, v.OfficerNote);
			local mainIndex = SGP_NameIndex(MemberTallyList, mainName);
			local TotalXP = 0;
			local WeeklyXP = 0;
			local Level = 0;
			local Achievement = 0;
			local Reputation = 4;
			if (mainIndex ~= nil) then
				if( mainIndex <= table.getn( MemberTallyList )) then
					TotalXP = MemberTallyList[mainIndex].TotalXP;
					WeeklyXP = MemberTallyList[mainIndex].WeeklyXP;
					Level = MemberTallyList[mainIndex].Level;
					Achievement = MemberTallyList[mainIndex].Achievement;
					Reputation = MemberTallyList[mainIndex].Reputation;
				end
			end
			local CurrentRankIndex = v.RankIndex;
			
			-- Find out the New Rank Index to work out whether this person should be promoted, demoted or nothing.
			local NewRankIndex = SGP_RankModifierCalculator(CurrentRankIndex, TotalXP, WeeklyXP, Level, Achievement, Reputation);
			
			if (v.Name ~= mainName and SGP.Settings.AltMode == 2) then
				NewRankIndex = SGP.Settings.AltRank+1; -- Add 1 because the AltRank list doesn't contain the GM.
			end
				
			v.NewRankIndex = NewRankIndex;
			if (NewRankIndex > CurrentRankIndex and SGP.Settings.GuildRanks[CurrentRankIndex].AllowDemote == 1 and
						not ((SGP.Settings.FilterDND == 2 and SGP_IsWordInString(SGP.Settings.FilterDNDText, v.Note)) or
							 (SGP.Settings.FilterDND == 3 and SGP_IsWordInString(SGP.Settings.FilterDNDText, v.OfficerNote)) or
							 (SGP.Settings.FilterDND == 4 and (SGP_IsWordInString(SGP.Settings.FilterDNDText, v.Note) or SGP_IsWordInString(SGP.Settings.FilterDNDText, v.OfficerNote))))) then
				-- Demote
				table.insert(SGP.DemoteList, v);
			elseif (NewRankIndex < CurrentRankIndex and SGP.Settings.GuildRanks[CurrentRankIndex].AllowPromote == 1 and
						not ((SGP.Settings.FilterDNP == 2 and SGP_IsWordInString(SGP.Settings.FilterDNPText, v.Note)) or
							 (SGP.Settings.FilterDNP == 3 and SGP_IsWordInString(SGP.Settings.FilterDNPText, v.OfficerNote)) or
							 (SGP.Settings.FilterDNP == 4 and (SGP_IsWordInString(SGP.Settings.FilterDNPText, v.Note) or SGP_IsWordInString(SGP.Settings.FilterDNPText, v.OfficerNote))))) then
				-- Promote
				table.insert(SGP.PromoteList, v);
			end
		end
	end
end

function SGP_RankModifierCalculator(CurrIndex, TotalXP, WeeklyXP, Level, Achievement, Reputation)
	local PlayerGuildName, PlayerGuildRankName, PlayerGuildRankIndex = GetGuildInfo("player");
	PlayerGuildRankIndex = PlayerGuildRankIndex + 1; -- PlayerGuildRankIndex is 0 based index. GuildControlGetRankName is 1 based index. So add one to compensate.
	
	-- Because Blizzard are stupid - Some people have -1 Achievement points. Lets assume that's 0.
	if (Achievement < 0) then
		Achievement = 0;
	end
	
	for i=(PlayerGuildRankIndex+1),SGP.Settings.GuildNumRanks do
		local CurrTotalXPMin = SGP.Settings.GuildRanks[i].TotalXP;
		local CurrWeeklyXPMin = SGP.Settings.GuildRanks[i].WeeklyXP;
		local CurrLevelMin = SGP.Settings.GuildRanks[i].Level;
		local CurrAchievementMin = SGP.Settings.GuildRanks[i].Achievement;
		local CurrReputationMin = SGP.Settings.GuildRanks[i].Reputation;
		-- If the rank is attainable and we have the required values.
		if (SGP.Settings.GuildRanks[i].Attainable == 1 and TotalXP >= CurrTotalXPMin and WeeklyXP >= CurrWeeklyXPMin and Level >= CurrLevelMin and Achievement >= CurrAchievementMin and Reputation >= CurrReputationMin) then
			local NewRankIndex = i;
			return NewRankIndex;
		end
	end
	-- If we're here then we either cannot change this person's rank, or something went the hell wrong. Assume they stay the same rank.
	return CurrIndex;
end

function SGP_Promote()
	SGP_ChatEcho("Promoting all under-ranked members.");
	for i,v in pairs(SGP.PromoteList) do
		if CanGuildPromote(v.Name) then
			SetGuildMemberRank(v.Index, v.NewRankIndex);
		else
			SGP_ErrorEcho("|cffC41F3BFailed|r to promote " .. v.Name .. ".");
		end
	end
	SGP_ClearLists("Promote");
	SGPFrameStuff.BUTTONTEXTS["UIPromoteButton"]:SetText(SGPLocal.UIPromoteButton .. ": 0");
end

function SGP_Demote()
	SGP_ChatEcho("Demoting all over-ranked members.");
	for i,v in pairs(SGP.DemoteList) do
		if CanGuildDemote(v.Name) then
			SetGuildMemberRank(v.Index, v.NewRankIndex);
		else
			SGP_ErrorEcho("|cffC41F3BFailed|r to demote " .. v.Name .. ".");
		end
	end
	SGP_ClearLists("Demote");
	SGPFrameStuff.BUTTONTEXTS["UIDemoteButton"]:SetText(SGPLocal.UIDemoteButton .. ": 0");
end